// Funciona

nslImport nslAllImports;

nslModule PreyApproach (int tx,int ty)  
{
	public NslDinFloat2 t5_2f(tx,ty);			
	public NslDinFloat0 psfo();
	//public NslDoutFloat0 ps();
	public NslDouble0 ps();
	public NslDoutFloat1 preyHor_f(tx);		
	private NslFloat1 preyHor(tx);		// Parcellation		(1D).
	private NslFloat1 preyHor_default(tx);
	private NslFloat2 preyF(tx, ty);		// PREY ATRACTANT FIELD (2D).
	private NslFloat0 prey_norm();		// Normalization
	private NslFloat2 t5_2_rf(80, 80);	// KERNEL for Prey Attractant Field.
	private NslFloat2 t5_2_erf(80, 80); 
	private NslFloat0 t5_2_erf_sig();
	private NslFloat0 t5_2_erf_wgt();
	private NslFloat0 rsfo();
	private NslFloat0 th();	

	public void initSys()
	{
		rsfo = 1.0;	// Prey & Prey Approach.
		ps = 0;

		DetourLib.gauss2D(t5_2_erf,t5_2_erf_sig);
		t5_2_rf = t5_2_erf_wgt * t5_2_erf;
	}

	public void simRun()
	{
		preyF = t5_2_rf * t5_2f;		
		//preyHor = nslReduceRow(preyF);	// Parcellation: horizontal comp.
		preyHor = nslSumRows(preyF);		

		ps = rsfo*psfo;    		
   		ps = NslSigmoid.eval(ps,-1.0,1.0,-1.0,1.0);

		if (ps > th) 
		{
			float mx = NslMaxValue.eval(preyHor);	
			if (mx != 0.0)
				preyHor_f = preyHor/mx;	// Normalize.
		}
		else
			preyHor_f = 0;
	}
}
